net.sf.saxon.expr

## Class XPathContextMinor

- java.lang.Object
- - net.sf.saxon.expr.XPathContextMinor

- All Implemented Interfaces:
    XPathContext
  Direct Known Subclasses:
    XPathContextMajor

      public class XPathContextMinor
      extends Object
      implements XPathContext

  This class represents a minor change in the dynamic context in which an XPath expression is evaluated: a "major context" object allows all aspects of the dynamic context to change, whereas a "minor context" only allows changes to the focus and the destination for push output.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `XPathContextMinor.LastValue` Container for cached value of the last() function.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected StackFrame` | `stackFrame`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `XPathContextMinor()` Private Constructor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `changeOutputDestination(Receiver receiver, ParseOptions options)` Set a new output destination, supplying the output format details.
    `Sequence` | `evaluateLocalVariable(int slotnumber)` Get the value of a local variable, identified by its slot number
    `XPathContext` | `getCaller()` Get the calling XPathContext (the next one down the stack).
    `StringCollator` | `getCollation(String name)` Get a named collation
    `Configuration` | `getConfiguration()` Get the Configuration
    `Item` | `getContextItem()` Get the context item
    `Controller` | `getController()` Get the Controller.
    `DateTimeValue` | `getCurrentDateTime()` Get the current date and time for this query or transformation.
    `XPathException` | `getCurrentException()` Get the current exception (in saxon:catch)
    `GroupIterator` | `getCurrentGroupIterator()` Get the current group iterator.
    `SequenceIterator` | `getCurrentIterator()` Get the current iterator.
    `Mode` | `getCurrentMode()` Get the current mode.
    `RegexIterator` | `getCurrentRegexIterator()` Get the current regex iterator.
    `Rule` | `getCurrentTemplateRule()` Get the current template.
    `int` | `getImplicitTimezone()` Get the implicit timezone, as a positive or negative offset from UTC in minutes.
    `int` | `getLast()` Get the context size (the position of the last item in the current node list)
    `ParameterSet` | `getLocalParameters()` Get the local parameters for the current template call.
    `NameChecker` | `getNameChecker()` Get a NameChecker for checking names against the XML 1.0 or XML 1.1 specification as appropriate
    `NamePool` | `getNamePool()` Get the Name Pool
    `SequenceReceiver` | `getReceiver()` Get the Receiver to which output is currently being written.
    `StackFrame` | `getStackFrame()` Get a reference to the local stack frame for variables.
    `ParameterSet` | `getTunnelParameters()` Get the tunnel parameters for the current template call.
    `boolean` | `isAtLast()` Determine whether the context position is the same as the context size that is, whether position()=last()
    `boolean` | `isTemporaryOutputState()` Ask whether the XSLT output state is "temporary" or "final"
    `Iterator` | `iterateStackFrames()` Get the context stack.
    `XPathContextMajor` | `newCleanContext()` Construct a new context without copying (used for the context in a function call)
    `XPathContextMajor` | `newContext()` Construct a new context as a copy of another.
    `XPathContextMinor` | `newMinorContext()` Construct a new context as a copy of another.
    `void` | `notifyChildThreads()`
    `void` | `setCaller(XPathContext caller)` Set the calling XPathContext
    `void` | `setCurrentException(XPathException exception)` Set the current exception (in saxon:catch)
    `void` | `setCurrentIterator(SequenceIterator iter)` Set a new sequence iterator.
    `void` | `setLocalVariable(int slotnumber, Sequence value)` Set the value of a local variable, identified by its slot number
    `void` | `setReceiver(SequenceReceiver receiver)` Change the Receiver to which output is written
    `int` | `useLocalParameter(int parameterId, int slotNumber, boolean isTunnel)` Use local parameter.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### stackFrame

          protected StackFrame stackFrame

  - ### Constructor Detail

    - #### XPathContextMinor

          protected XPathContextMinor()

      Private Constructor

  - ### Method Detail

    - #### newContext

          public XPathContextMajor newContext()

      Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context
      Specified by:
        `newContext` in interface `XPathContext`
      Returns:
        a new context, created as a copy of this context

    - #### newMinorContext

          public XPathContextMinor newMinorContext()

      Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context
      Specified by:
        `newMinorContext` in interface `XPathContext`
      Returns:
        a new minor context

    - #### setCaller

          public void setCaller(XPathContext caller)

      Set the calling XPathContext
      Specified by:
        `setCaller` in interface `XPathContext`
      Parameters:
        `caller` - the XPathContext of the calling expression

    - #### newCleanContext

          public XPathContextMajor newCleanContext()

      Construct a new context without copying (used for the context in a function call)
      Specified by:
        `newCleanContext` in interface `XPathContext`
      Returns:
        a new clean context

    - #### getLocalParameters

          public ParameterSet getLocalParameters()

      Get the local parameters for the current template call.
      Specified by:
        `getLocalParameters` in interface `XPathContext`
      Returns:
        the supplied parameters

    - #### getTunnelParameters

          public ParameterSet getTunnelParameters()

      Get the tunnel parameters for the current template call.
      Specified by:
        `getTunnelParameters` in interface `XPathContext`
      Returns:
        the supplied tunnel parameters

    - #### getController

          public final Controller getController()

      Get the Controller. May return null when running outside XSLT or XQuery
      Specified by:
        `getController` in interface `XPathContext`
      Returns:
        the controller for this query or transformation

    - #### getConfiguration

          public final Configuration getConfiguration()

      Get the Configuration
      Specified by:
        `getConfiguration` in interface `XPathContext`
      Returns:
        the Saxon configuration object

    - #### getNamePool

          public final NamePool getNamePool()

      Get the Name Pool
      Specified by:
        `getNamePool` in interface `XPathContext`
      Returns:
        the name pool

    - #### getNameChecker

          public final NameChecker getNameChecker()

      Get a NameChecker for checking names against the XML 1.0 or XML 1.1 specification as appropriate
      Returns:
        the appropriate name checker

    - #### getCaller

          public final XPathContext getCaller()

      Get the calling XPathContext (the next one down the stack). This will be null if unknown, or if the bottom of the stack has been reached.
      Specified by:
        `getCaller` in interface `XPathContext`
      Returns:
        the XPathContext of the calling expression

    - #### setCurrentIterator

          public void setCurrentIterator(SequenceIterator iter)

      Set a new sequence iterator.
      Specified by:
        `setCurrentIterator` in interface `XPathContext`
      Parameters:
        `iter` - the current iterator. The context item, position, and size are determined by reference to the current iterator.

    - #### getCurrentIterator

          public final SequenceIterator getCurrentIterator()

      Get the current iterator. This encapsulates the context item, context position, and context size.
      Specified by:
        `getCurrentIterator` in interface `XPathContext`
      Returns:
        the current iterator, or null if there is no current iterator (which means the context item, position, and size are undefined).

    - #### getContextItem

          public final Item getContextItem()

      Get the context item
      Specified by:
        `getContextItem` in interface `XPathContext`
      Returns:
        the context item, or null if the context item is undefined

    - #### getLast

          public final int getLast()
                            throws XPathException

      Get the context size (the position of the last item in the current node list)
      Specified by:
        `getLast` in interface `XPathContext`
      Returns:
        the context size
      Throws:
        `XPathException` - if the context position is undefined

    - #### isAtLast

          public final boolean isAtLast()
                                 throws XPathException

      Determine whether the context position is the same as the context size that is, whether position()=last()
      Specified by:
        `isAtLast` in interface `XPathContext`
      Returns:
        true if the context position is the same as the context size.
      Throws:
        `XPathException`

    - #### getCollation

          public final StringCollator getCollation(String name)
                                            throws XPathException

      Get a named collation
      Specified by:
        `getCollation` in interface `XPathContext`
      Parameters:
        `name` - the name (URI) of the required collation
      Returns:
        a StringCollator representing the collation
      Throws:
        `XPathException` - if the collation is not recognized

    - #### getStackFrame

          public StackFrame getStackFrame()

      Get a reference to the local stack frame for variables. Note that it's the caller's job to make a local copy of this. This is used for creating a Closure containing a retained copy of the variables for delayed evaluation.
      Specified by:
        `getStackFrame` in interface `XPathContext`
      Returns:
        array of variables.

    - #### evaluateLocalVariable

          public final Sequence evaluateLocalVariable(int slotnumber)

      Get the value of a local variable, identified by its slot number
      Specified by:
        `evaluateLocalVariable` in interface `XPathContext`
      Parameters:
        `slotnumber` - the slot number allocated at compile time to the variable, which identifies its position within the local stack frame
      Returns:
        the value of the variable.

    - #### setLocalVariable

          public final void setLocalVariable(int slotnumber,
                              Sequence value)

      Set the value of a local variable, identified by its slot number
      Specified by:
        `setLocalVariable` in interface `XPathContext`
      Parameters:
        `slotnumber` - the slot number allocated at compile time to the variable, which identifies its position within the local stack frame
        `value` - the value of the variable

    - #### notifyChildThreads

          public void notifyChildThreads()
                                  throws XPathException

      Specified by:
        `notifyChildThreads` in interface `XPathContext`
      Throws:
        `XPathException`

    - #### changeOutputDestination

          public void changeOutputDestination(Receiver receiver,
                                     ParseOptions options)
                                       throws XPathException

      Set a new output destination, supplying the output format details.
      This affects all further output until resetOutputDestination() is called. Note that it is the caller's responsibility to close the Writer after use.
      Specified by:
        `changeOutputDestination` in interface `XPathContext`
      Parameters:
        `options` - options for validating the output stream; may be null
        `receiver` - the new output destination
      Throws:
        `XPathException` - if any dynamic error occurs; and specifically, if an attempt is made to switch to a final output destination while writing a temporary tree or sequence @param isFinal true if the destination is a final result tree (either the principal output or a secondary result tree); false if @param validation Validation to be performed on the output document

    - #### setReceiver

          public void setReceiver(SequenceReceiver receiver)

      Change the Receiver to which output is written
      Specified by:
        `setReceiver` in interface `XPathContext`
      Parameters:
        `receiver` - the SequenceReceiver to be used

    - #### getReceiver

          public final SequenceReceiver getReceiver()

      Get the Receiver to which output is currently being written.
      Specified by:
        `getReceiver` in interface `XPathContext`
      Returns:
        the current Receiver

    - #### isTemporaryOutputState

          public boolean isTemporaryOutputState()

      Ask whether the XSLT output state is "temporary" or "final"
      Specified by:
        `isTemporaryOutputState` in interface `XPathContext`
      Returns:
        true to set temporary output state; false to set final output state

    - #### useLocalParameter

          public int useLocalParameter(int parameterId,
                              int slotNumber,
                              boolean isTunnel)
                                throws XPathException

      Use local parameter. This is called when a local xsl:param element is processed. If a parameter of the relevant name was supplied, it is bound to the xsl:param element. Otherwise the method returns false, so the xsl:param default will be evaluated
      Specified by:
        `useLocalParameter` in interface `XPathContext`
      Parameters:
        `parameterId` -
        `slotNumber` -
        `isTunnel` - True if a tunnel parameter is required, else false @return ParameterSet.NOT_SUPPLIED, ParameterSet.SUPPLIED, or ParameterSet.SUPPLIED_AND_CHECKED
      Returns:
        ParameterSet.NOT_SUPPLIED, ParameterSet.SUPPLIED, or ParameterSet.SUPPLIED_AND_CHECKED
      Throws:
        `XPathException`

    - #### getCurrentMode

          public Mode getCurrentMode()

      Get the current mode.
      Specified by:
        `getCurrentMode` in interface `XPathContext`
      Returns:
        the current mode

    - #### getCurrentTemplateRule

          public Rule getCurrentTemplateRule()

      Get the current template. This is used to support xsl:apply-imports
      Specified by:
        `getCurrentTemplateRule` in interface `XPathContext`
      Returns:
        the current template

    - #### getCurrentGroupIterator

          public GroupIterator getCurrentGroupIterator()

      Get the current group iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0
      Specified by:
        `getCurrentGroupIterator` in interface `XPathContext`
      Returns:
        the current grouped collection

    - #### getCurrentRegexIterator

          public RegexIterator getCurrentRegexIterator()

      Get the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.
      Specified by:
        `getCurrentRegexIterator` in interface `XPathContext`
      Returns:
        the current regular expressions iterator

    - #### getCurrentDateTime

          public DateTimeValue getCurrentDateTime()

      Get the current date and time for this query or transformation. All calls during one transformation return the same answer.
      Specified by:
        `getCurrentDateTime` in interface `XPathContext`
      Returns:
        Get the current date and time. This will deliver the same value for repeated calls within the same transformation

    - #### getImplicitTimezone

          public final int getImplicitTimezone()

      Get the implicit timezone, as a positive or negative offset from UTC in minutes. The range is -14hours to +14hours
      Specified by:
        `getImplicitTimezone` in interface `XPathContext`
      Returns:
        the implicit timezone as an offset from UTC in minutes

    - #### iterateStackFrames

          public Iterator iterateStackFrames()

      Get the context stack. This method returns an iterator whose items are instances of `ContextStackFrame`, starting with the top-most stackframe and ending at the point the query or transformation was invoked by a calling application.
      Specified by:
        `iterateStackFrames` in interface `XPathContext`
      Returns:
        an iterator over a copy of the run-time call stack

    - #### setCurrentException

          public void setCurrentException(XPathException exception)

      Set the current exception (in saxon:catch)
      Parameters:
        `exception` - the current exception

    - #### getCurrentException

          public XPathException getCurrentException()

      Get the current exception (in saxon:catch)
      Specified by:
        `getCurrentException` in interface `XPathContext`
      Returns:
        the current exception, or null if there is none defined

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.